Index: GTP/trunk/Lib/Geom/shared/GTGeometry/src/GeoMeshLoader.cpp
===================================================================
--- GTP/trunk/Lib/Geom/shared/GTGeometry/src/GeoMeshLoader.cpp	(revision 1136)
+++ GTP/trunk/Lib/Geom/shared/GTGeometry/src/GeoMeshLoader.cpp	(revision 1526)
@@ -681,15 +681,20 @@
 			{
 				case 0xabcd:
+					
+					//	Debug.
 					cout << "LODSTRIPS_Chunk" << endl;
+					
 					lodstripsdata = new Geometry::LodStripsLibraryData;
 
-					int				aux,v,c;
+					int							aux,v,c;
 					LODRegisterType	lod_register;
-					LODData			dataaux;
-					int				tam;
+					LODData					dataaux;
+					int							tam;
 
 					fread(&tam, sizeof(int), 1, f);
+					
 					lodstripsdata->mFileVertices.clear();
-					for (v=0; v<tam; v++)
+					
+					for (v	=	0; v < tam; v++)
 					{
 						fread(&aux, sizeof(int), 1, f);
@@ -698,6 +703,8 @@
 
 					lodstripsdata->mFileChangesLOD.clear();
+					
 					fread(&tam, sizeof(int), 1, f);
-					for (c=0; c<tam; c++)
+					
+					for (c	=	0; c < tam; c++)
 					{
 						fread(&dataaux, sizeof(LODData), 1, f);
@@ -706,6 +713,5 @@
 						lod_register.vertexRepetition= dataaux.nL1;
 						lod_register.edgeRepetition= dataaux.nL2;
-						//lod_register.obligatory=false;
-						//lod_register.obligatory= dataaux.obligatory;
+						lod_register.obligatory=dataaux.obligatory;
 
 						lodstripsdata->mFileChangesLOD.push_back(lod_register);
@@ -713,6 +719,8 @@
 					
 					lodstripsdata->mData.clear();
+					
 					fread(&tam, sizeof(int), 1, f);
-					for (int b=0; b<tam; b++)
+					
+					for (int	b	=	0; b < tam; b++)
 					{
 						fread(&aux, sizeof(int), 1, f);
@@ -721,10 +729,12 @@
 
 					lodstripsdata->p_changes.clear();
+					
 					fread(&tam, sizeof(int), 1, f);
-					for (int p=0; p<tam; p++)
+					
+					for (int	p	=	0; p < tam; p++)
 					{
 						fread(&aux, sizeof(int), 1, f);
 						lodstripsdata->p_changes.push_back(aux);
-					}					
+					}
 
 					break;
@@ -1146,5 +1156,5 @@
 				cout	<<	version	<<	endl;
 
-				if (strcmp(version,"[MeshSerializer_v1.30]\n"))
+				/*if (strcmp(version,"[MeshSerializer_v1.30]\n"))
 				{
 					//	Debug.
@@ -1156,5 +1166,5 @@
 					//	Error.
 					mError	=	true;
-				}
+				}*/
 
 				while(!feof(pFile))
@@ -1423,7 +1433,7 @@
 //	Read bones of the submesh.
 //---------------------------------------------------------------------------
-void GeoMeshLoader::readSubMeshBoneAssignment(FILE* f,
-																							SubMesh* geoSubMesh,
-																							int option)
+void GeoMeshLoader::readSubMeshBoneAssignment(FILE		*f,
+																							SubMesh	*geoSubMesh,
+																							int			option)
 {
 	if (option == GEOMESH_BUILD)
@@ -1445,5 +1455,5 @@
 //	Read bones of the main mesh.
 //---------------------------------------------------------------------------
-void GeoMeshLoader::readMeshBoneAssignment(FILE* f, Mesh* geoMesh,int option)
+void GeoMeshLoader::readMeshBoneAssignment(FILE	*f, Mesh	*geoMesh,	int option)
 {
 	if (option == GEOMESH_BUILD)
@@ -1465,5 +1475,5 @@
 //	Read skeleton link.
 //---------------------------------------------------------------------------
-void GeoMeshLoader::readSkeletonLink(FILE* f, Mesh* geoMesh,int option)
+void GeoMeshLoader::readSkeletonLink(FILE	*f, Mesh	*geoMesh,	int option)
 {
 	if (option == GEOMESH_BUILD)
@@ -1829,4 +1839,5 @@
 		const std::vector<face_t> & vecfaces = faces[i];
 		std::vector<Geometry::Index> aux_indices;
+		
 		submesh->mSharedVertexBuffer = true;
 		submesh->mIndexCount = vecfaces.size()*3;
Index: GTP/trunk/Lib/Geom/shared/GTGeometry/src/GeoLodStripsConstructor.cpp
===================================================================
--- GTP/trunk/Lib/Geom/shared/GTGeometry/src/GeoLodStripsConstructor.cpp	(revision 1136)
+++ GTP/trunk/Lib/Geom/shared/GTGeometry/src/GeoLodStripsConstructor.cpp	(revision 1526)
@@ -27,24 +27,21 @@
 void LodStripsConstructor::CalcularCambiosLODsVNuevaED(TIPOFUNC upb)
 {
-//	LODPosition						pos;
-//	vector	<LODPosition>	listaPos;
-	long 		int							k;
-	long 		int							i;
-	unsigned long 		int		t;
-	long 		int							r;
-	unsigned long 		int		v;
-	long 		int							p0;
-	long 		int							lod	=	0;
-	long 		int							sigue;
-	long 		int							ac[3]	=	{0,0,0};
-	long 		int							totalRegs	=	0;
-	long 		int							RegsCambios;
-	std::vector<std::vector<int> >			TiraOriginal;
-	LODData 								regLOD;
-	//LODChanges							listaCambios;
-	std::vector<LODData>						listaCambios;
-	float										percent;
-	float										increment;
-	long		int							update;
+	long 		int					k;
+	long 		int					i;
+	unsigned long 		int			t;
+	long 		int					r;
+	unsigned long 		int			v;
+	long 		int					p0;
+	long 		int					lod	=	0;
+	long 		int					sigue;
+	long 		int					ac[3]	=	{0,0,0};
+	long 		int					totalRegs	=	0;
+	long 		int					RegsCambios;
+	std::vector<std::vector<int> >	TiraOriginal;
+	LODData 						regLOD;
+	std::vector<LODData>			listaCambios;
+	float							percent;
+	float							increment;
+	long		int					update;
 
 	//	Saves original copy.
@@ -68,23 +65,16 @@
 	
 	this->LodsDisp	=	this->TOTALCAMBIOS	=	lod;
-	pCambios				=	new uint32[this->TOTALCAMBIOS];
-	pCambios[0]			=	0;
+	pCambios		=	new uint32[this->TOTALCAMBIOS];
+	pCambios[0]		=	0;
 	
 	for	(lod = 0; ((this->cVerts[lod].Next) != -1); lod++)
 	{
-/*		if (update	!= (int)(increment * lod))
-		{
-			update	=	(int)(increment * lod);
-			upb(percent);
-		}*/
-
 		tipoVertice & cVertsLOD = this->cVerts[lod];
 		
 		RegsCambios				=	0;
-		regLOD.obligatory	=	this->Ordenacion[lod].obligatorio;
+		regLOD.obligatory	=	this->Ordenacion[lod].obligatory;
 		
 		for(t = 0; t < this->cStrips.size(); t++)
 		{
-
 			std::vector<int> & cStripsT = this->cStrips[t];
 
@@ -101,7 +91,5 @@
 					//	Strips.
 					if (regLOD.strip == this->MARCAVACIO)
-					{
-						regLOD.strip	=	t;
-					}
+						regLOD.strip = t;
 					
 					++totalRegs;
@@ -118,8 +106,8 @@
 			//	Changes for simplification of level 1 to greater than 2.
 			totalRegs	=	0;
-			i					=	0;
-			r					=	0;
-			sigue			=	0;
-			k					=	long(cStripsT.size()-3);
+			i			=	0;
+			r			=	0;
+			sigue		=	0;
+			k			=	long(cStripsT.size()-3);
 			
 			while (i < k)
@@ -305,16 +293,13 @@
 	long int vSig;
 	long int k;
-	VECTORVERTEX				Vertices;
+	VECTORVERTEX			Vertices;
 	std::vector<tipoVertice>		NuevosVerts;
-	//vector	<VECTORINT>	NuevasTiras;
-	std::vector<std::vector<int> > NuevasTiras;
-//	VECTORINT						tira;
-	std::vector<int> tira;
-	vector	<Index>			mV1Aux;
-	tipoOrden						Orden;
-	tipoOrden						*Ord;
-	bool								bEncontrado;
-	long	int						c1;
-	long	int						c2;
+	std::vector<std::vector<int> >	NuevasTiras;
+	std::vector<int> 		tira;
+	tipoOrden				Orden;
+	tipoOrden				*Ord;
+	bool					bEncontrado;
+
+
 	//	Progress bar
 	float			percent;
@@ -326,7 +311,4 @@
 	size_t	mStepsSize = mGeoMeshSQ->mSteps.size();
 
-	c1					=	0;
-	c2					=	0;
-	
 	update			=	-1;
 	percent			=	1.0;
@@ -341,21 +323,18 @@
 		}
 		
-		const Geometry::MeshSimplificationSequence::Step & theStep = this->mGeoMeshSQ->mSteps[i];
-
-		mV1Aux.push_back(theStep.mV1);
+		const MeshSimplificationSequence::Step & theStep = this->mGeoMeshSQ->mSteps[i];
 
 		Orden.vQslimNext	=	theStep.mV0;
-		Orden.vQslim			=	theStep.mV1;
-		Orden.obligatorio	=	theStep.obligatorio;
-		Orden.vLS					=	i;
-
-		Orden.x						=	theStep.x;
-		Orden.vLSNext			=	-1;
-		Orden.cambio			=	"n";
+		Orden.vQslim		=	theStep.mV1;
+		Orden.obligatory	=	theStep.obligatory;
+		Orden.vLS			=	i;
+
+		Orden.x				=	theStep.x;
+		Orden.vLSNext		=	-1;
+		Orden.cambio		=	"n";
 
 		Ordenacion.push_back(Orden);
 	}
 	
-	this->NumVertsRepetidos = c2;
 
 	update		=	-1;
@@ -363,39 +342,4 @@
 	percent		=	1.0;
 
-	//	Change all vertices that have x != 0.
-	for(i	=	0;	i < Ordenacion.size();	i++)
-	{
-		if (update	!= (int)(i * increment))
-		{
-			update	= (int)(i * increment);
-			upb(percent);
-		}
-		
-		Ord	=	&(Ordenacion[i]);
-
-		if (Ord->x!=0)
-		{
-			//	Change the simplification order.
-			v								=	Ord->vQslim;
-			Ord->vQslim			=	Ord->vQslimNext;
-			Ord->vQslimNext	=	v;
-
-			for (j = i+1; j < Ordenacion.size(); j++)
-			{
-				tipoOrden & ordJ = Ordenacion[j];
-				if (ordJ.vQslim == Ord->vQslim)
-				{
-					ordJ.vQslim	=	Ord->vQslimNext;
-					ordJ.cambio	=	"y";
-				}
-				else if (ordJ.vQslimNext == Ord->vQslim)
-				{
-					ordJ.vQslimNext	=	Ord->vQslimNext;	
-					ordJ.cambio			=	"y";
-				}
-			}
-		}
-	}
-
 	update		=	-1;
 	increment	=	(float)(10.0) / (float)(Ordenacion.size());
@@ -412,8 +356,10 @@
 		}
 
-		c1++;
-		NuevosVerts.push_back(this->cVerts[Ordenacion[i].vQslim]);
-
-		cVerts[Ordenacion[i].vQslim].Next	=	-1;
+		int OrdvQslim = Ordenacion[i].vQslim;
+		int OrdvQslimNext = Ordenacion[i].vQslimNext;
+
+		NuevosVerts.push_back(this->cVerts[OrdvQslim]);
+
+		cVerts[OrdvQslim].Next	=	-1;
 
 	}
@@ -421,5 +367,5 @@
 	//	Añadir aquellos vertices que no estaban en NuevosVerts 
 	//	y no se simplificaban.
-	int cont				=	0;
+	int cont		=	0;
 	int contestaban	=	0;
 
@@ -431,8 +377,8 @@
 			cont++;
 			NuevosVerts.push_back(this->cVerts[i]);
-			Orden.vLS					=	int(Ordenacion.size());
-			Orden.obligatorio	= 0;
-			Orden.vLSNext			=	-1;
-			Orden.vQslim			=	i;
+			Orden.vLS			=	int(Ordenacion.size());
+			Orden.obligatory	= 0;
+			Orden.vLSNext		=	-1;
+			Orden.vQslim		=	i;
 			Orden.vQslimNext	=	-1;
 
@@ -466,11 +412,11 @@
 		for (t = 0; t < Ordenacion.size() && !vSig;t++)
 		{
-			if (Ordenacion[t].vQslim==v)
-			{
-				vSig=Ordenacion[t].vLS;
-			}
-		}
-
-		if (vSig!=0)
+			if (Ordenacion[t].vQslim == v)
+			{
+				vSig	=	Ordenacion[t].vLS;
+			}
+		}
+
+		if (vSig != 0)
 		{
 			Ordenacion[i].vLSNext	=	vSig;
@@ -485,6 +431,9 @@
 
 		size_t	cStripsSizeT = this->cStrips[t].size();
+
 		for(i = 0; i < cStripsSizeT; i++)
+		{
 			tira.push_back(0);
+		}
 
 		NuevasTiras.push_back(tira);
@@ -499,5 +448,6 @@
 	//	2 min.
 	//Cambiar los vertices de las tiras
-	size_t	NuevosVertsSize = NuevosVerts.size();	
+	size_t	NuevosVertsSize = NuevosVerts.size();
+
 	for(v = 0; v < NuevosVertsSize; v++)
 	{
@@ -515,4 +465,5 @@
 			std::vector<int> & NuevasTirasT = NuevasTiras[t];
 			size_t	cStripsSizeT = thisStrip.size();
+
 			for(i = 0; i < cStripsSizeT; i++)
 			{
@@ -531,4 +482,5 @@
 	//NuevosVerts y Ordenacion = tamaño.
 	NuevosVertsSize = NuevosVerts.size();
+
 	for(i = 0; i < NuevosVertsSize; i++)
 	{
@@ -563,4 +515,7 @@
 	
 	this->mGeoMeshSQ	=	const_cast<MeshSimplificationSequence*>(ms);
+
+	//	Add new vertices to mesh.
+	AddNewVertices();
 
 	//	Set the leaves submesh.
@@ -612,13 +567,9 @@
 void LodStripsConstructor::Save(std::string filename)
 {
-	//size_t	i, j;
-	int			k	=	0;
-	char		simp[256];
-
 	int vertexCount		=	(int)this->cVerts.size();
 	int changesCount	=	(int)this->cCambios.size();
-	int dataCount			=	(int)this->cDatos.size();
+	int dataCount		=	(int)this->cDatos.size();
 	int cambiosCount	=	this->TOTALCAMBIOS;
-	int size					=	changesCount*sizeof(LODData) + 
+	int size			=	changesCount*sizeof(LODData) + 
 				(vertexCount + dataCount + cambiosCount + 4)*sizeof(int) +
 				CHUNK_OVERHEAD_SIZE;
@@ -630,4 +581,5 @@
 	fwrite(&size,sizeof(unsigned long),1,f);
 
+	// VERTICES
 	fwrite(&vertexCount, sizeof(int), 1, f);
 	for(size_t	i = 0; i < this->cVerts.size(); i++)
@@ -636,12 +588,4 @@
 		fwrite(&auxv, sizeof(int), 1, f);
 	}
-
-	//	VERTICES.
-/*	for(i = 0; i < this->cVerts.size(); i++)
-	{
-		sprintf(simp,"v %d\n",cVerts[i].Next);
-		oSerializer.WriteData(simp,sizeof(char),strlen(simp));
-	}
-*/
 	
 	//	CSTRIPS.
@@ -649,7 +593,5 @@
 	
 	for(size_t	i = 0; i < this->cStrips.size(); i++)
-	{
 		this->TOTALINDICES += int(this->cStrips[i].size());
-	}
 
 	//	lines starting with a d.
@@ -662,25 +604,6 @@
 	}
 
-
-/*	for(i = 0; i < this->cCambios.size(); i++)
-	{
-		sprintf(simp,"c\n");
-		oSerializer.WriteData(simp,sizeof(char),strlen(simp));
-		
-		sprintf(simp,
-						"d %u %u %u %u %u\n",
-						cCambios[i].strip,
-						cCambios[i].nP,
-						cCambios[i].nL1,
-						cCambios[i].nL2,
-						cCambios[i].obligatory);
-		
-		oSerializer.WriteData(simp,sizeof(char),strlen(simp));
-	}
-*/	//	Lines starting with a b.
 	//	Data.
-
 	fwrite(&dataCount, sizeof(int), 1, f);
-
 	for(size_t	i = 0; i < this->cDatos.size(); i++)
 	{
@@ -688,15 +611,4 @@
 		fwrite(&data, sizeof(int), 1, f);
 	}
-
-	sprintf(simp,"a\n");
-/*	oSerializer.WriteData(simp,sizeof(char),strlen(simp));
-	
-	for(i = 0; i < this->cDatos.size(); i++)
-	{
-		sprintf(simp,"b %d\n",cDatos[i]);
-
-		oSerializer.WriteData(simp,sizeof(char),strlen(simp));
-	}
-*/
 
 	//	lines starting with a p.
@@ -711,60 +623,4 @@
 
 	fclose(f);
-
-/*
-	//	VERTICES.
-	for(i = 0; i < this->cVerts.size(); i++)
-	{
-		sprintf(simp,"v %d\n",cVerts[i].Next);
-		oSerializer.WriteData(simp,sizeof(char),strlen(simp));
-	}
-
-	//	CSTRIPS.
-	this->TOTALINDICES	=	0;
-	
-	for(i = 0; i < this->cStrips.size(); i++)
-	{
-		this->TOTALINDICES += int(this->cStrips[i].size());
-	}
-
-	//	lines starting with a d.
-	//	Changes
-	for(i = 0; i < this->cCambios.size(); i++)
-	{
-		sprintf(simp,"c\n");
-		oSerializer.WriteData(simp,sizeof(char),strlen(simp));
-		
-		sprintf(simp,
-						"d %u %u %u %u %u\n",
-						cCambios[i].strip,
-						cCambios[i].nP,
-						cCambios[i].nL1,
-						cCambios[i].nL2,
-						cCambios[i].obligatory);
-		
-		oSerializer.WriteData(simp,sizeof(char),strlen(simp));
-	}
-	//	Lines starting with a b.
-	//	Data.
-	sprintf(simp,"a\n");
-	oSerializer.WriteData(simp,sizeof(char),strlen(simp));
-	
-	for(i = 0; i < this->cDatos.size(); i++)
-	{
-		sprintf(simp,"b %d\n",cDatos[i]);
-
-		oSerializer.WriteData(simp,sizeof(char),strlen(simp));
-	}
-
-	//	lines starting with a p.
-	//	Chages made in a LOD.
-	for(i = 0; i < this->TOTALCAMBIOS; i++)
-	{
-		sprintf(simp,"p %d\n",this->pCambios[i]);
-
-		oSerializer.WriteData(simp,sizeof(char),strlen(simp));
-	}
-
-	oSerializer.WriteData("\n",sizeof(char),1);	*/
 }
 
@@ -815,10 +671,8 @@
 	for(i = 0; i < this->TOTALTIRAS; i++)
 	{
-		t	=	long(this->cStrips[i].size());
+		t = long(this->cStrips[i].size());
 		
 		if (t > max)
-		{
-			max	=	t;
-		}
+			max	= t;
 	}
 
@@ -970,8 +824,7 @@
 				}
 
-				vAux.Next			=	-10;
-				vAux.numMesh	=	0;
-			
-				vAux.obligatorio	=	0;
+				vAux.Next		=	-10;
+				vAux.numMesh	=	0;			
+				vAux.obligatory	=	0;
 				
 				this->cVerts.push_back(vAux);
@@ -1170,12 +1023,11 @@
 		{
 			assign.boneIndex	=	0;
-			assign.weight			=	1;
-
-			for (	size_t	m = copy_vb->mVertexCount;
+			assign.weight		=	1;
+
+			for (size_t	m = copy_vb->mVertexCount;
 						m < mesh_vb->mVertexCount;
 						m++)
 			{
 				assign.vertexIndex	=	(unsigned int)m;
-				
 				mesh_bones->push_back(assign);
 			}
@@ -1185,12 +1037,9 @@
 			{
 				n	=	(*mesh_bones)[m].vertexIndex;
-
 				o	=	0;
 				
-				while (!(	(mesh_vb->mPosition[n].x == copy_vb->mPosition[o].x)
-									&&
-									(mesh_vb->mPosition[n].y == copy_vb->mPosition[o].y)
-									&&
-									(mesh_vb->mPosition[n].z == copy_vb->mPosition[o].z)))
+				while (!(	(mesh_vb->mPosition[n].x == copy_vb->mPosition[o].x)	&&
+							(mesh_vb->mPosition[n].y == copy_vb->mPosition[o].y)	&&
+							(mesh_vb->mPosition[n].z == copy_vb->mPosition[o].z)))
 				{
 					o++;
@@ -1200,7 +1049,5 @@
 				
 				while ((*copy_bones)[p].vertexIndex != o)
-				{
 					p++;
-				}
 
 				//	Same bone for 'm' and 'p'.
@@ -1244,5 +1091,5 @@
 }
 
-void Geometry::LodStripsConstructor::UpdateMesh(void)
+void LodStripsConstructor::UpdateMesh(void)
 {
 	int num_no	=	0;
@@ -1303,5 +1150,4 @@
 
 			indice++;
-
 		}
 
@@ -1436,2 +1282,78 @@
 	}
 }
+
+//---------------------------------------------------------------------------
+//	Add new vertices to mesh.
+//---------------------------------------------------------------------------
+void LodStripsConstructor::AddNewVertices()
+{
+	int				num_vertices;
+	SubMesh			*geosubmesh;
+	VertexBuffer	*vertex_buffer;
+	VertexBuffer	*new_vertex_buffer;
+
+	//	Gets old vertex buffer.
+	vertex_buffer	=	mGeoMesh->mVertexBuffer;
+	
+	num_vertices	=	vertex_buffer->mVertexCount
+									+
+						mGeoMeshSQ->mNewVertices.size();
+
+	//	Initialize auxiliar vertex buffer.
+	new_vertex_buffer	=	new	VertexBuffer();
+
+	new_vertex_buffer->mVertexCount	=	num_vertices;
+	
+	new_vertex_buffer->mPosition		=	new	Vector3[num_vertices];
+	new_vertex_buffer->mNormal			=	new	Vector3[num_vertices];
+	new_vertex_buffer->mTexCoords		=	new	Vector2[num_vertices];
+
+	new_vertex_buffer->mVertexInfo	=	vertex_buffer->mVertexInfo;
+
+	//	Num old vertices.
+	num_vertices	=	vertex_buffer->mVertexCount;
+
+	//	Copy the old vertex buffer.
+	for	(unsigned	int	i	=	0;	i < num_vertices;	i++)
+	{
+		new_vertex_buffer->mPosition[i]	=	vertex_buffer->mPosition[i];
+		new_vertex_buffer->mNormal[i]	=	vertex_buffer->mNormal[i];
+		new_vertex_buffer->mTexCoords[i]=	vertex_buffer->mTexCoords[i];
+	}
+
+
+	//	Copy new vertices.
+	for (unsigned	int	i	=	0;	i < mGeoMeshSQ->mNewVertices.size();	i++)
+	{
+		new_vertex_buffer->mPosition[num_vertices + i] = mGeoMeshSQ->mNewVertices[i].position;
+		new_vertex_buffer->mTexCoords[num_vertices + i]	= mGeoMeshSQ->mNewVertices[i].texcoord;
+		new_vertex_buffer->mNormal[num_vertices + i] = mGeoMeshSQ->mNewVertices[i].normal;
+
+		// check if my twin-vertex-bone has a bone assignment
+		// we check only the GeoMesh bones because the lodstrips only works for sharedvertex bones
+		for (std::vector<VertexBoneAssignment>::iterator it = mGeoMesh->mBones.begin(); it != mGeoMesh->mBones.end(); it ++)
+		{
+			if (it->vertexIndex == mGeoMeshSQ->mNewVertices[i].bonefrom)
+			{
+				VertexBoneAssignment vba;
+				vba.boneIndex = it->boneIndex;
+				vba.vertexIndex = mGeoMeshSQ->mNewVertices[i].id;
+				vba.weight = it->weight;
+				mGeoMesh->mBones.push_back(vba);
+			}
+		}
+	}
+
+	//	For each submesh.
+	for (unsigned int submesh	=	0; submesh < mGeoMesh->mSubMeshCount; submesh++)
+	{
+		geosubmesh	=	&mGeoMesh->mSubMesh[submesh];
+
+		geosubmesh->mVertexBuffer	=	new_vertex_buffer;
+	}
+
+	delete	vertex_buffer;
+	
+	mGeoMesh->mVertexBuffer	=	new_vertex_buffer;
+}
+
Index: GTP/trunk/Lib/Geom/shared/GTGeometry/GTGeometry.vcproj
===================================================================
--- GTP/trunk/Lib/Geom/shared/GTGeometry/GTGeometry.vcproj	(revision 1090)
+++ GTP/trunk/Lib/Geom/shared/GTGeometry/GTGeometry.vcproj	(revision 1526)
@@ -20,5 +20,5 @@
 				Name="VCCLCompilerTool"
 				Optimization="0"
-				AdditionalIncludeDirectories=".\src\libs;.\include;.\src\libs\vmi\include"
+				AdditionalIncludeDirectories=".\src\libs;.\include;.\src\libs\vmi\include;.\src\libs\ntl"
 				PreprocessorDefinitions="WIN32;_DEBUG;_LIB;GLEW_STATIC"
 				MinimalRebuild="TRUE"
@@ -63,5 +63,5 @@
 				Name="VCCLCompilerTool"
 				Optimization="2"
-				AdditionalIncludeDirectories=".\src\libs;.\include;.\src\libs\vmi\include"
+				AdditionalIncludeDirectories=".\src\libs;.\include;.\src\libs\vmi\include;.\src\libs\ntl"
 				PreprocessorDefinitions="WIN32;NDEBUG;_LIB;GLEW_STATIC"
 				MinimalRebuild="TRUE"
@@ -324,4 +324,11 @@
 				<File
 					RelativePath=".\src\libs\vmi\src\simplify.cpp">
+				</File>
+			</Filter>
+			<Filter
+				Name="ntl"
+				Filter="">
+				<File
+					RelativePath=".\src\libs\ntl\Cont.cpp">
 				</File>
 			</Filter>
Index: GTP/trunk/Lib/Geom/shared/GeoTool/include/GeoMeshViewUI.h
===================================================================
--- GTP/trunk/Lib/Geom/shared/GeoTool/include/GeoMeshViewUI.h	(revision 1090)
+++ GTP/trunk/Lib/Geom/shared/GeoTool/include/GeoMeshViewUI.h	(revision 1526)
@@ -87,4 +87,46 @@
 using	namespace	Geometry;
 
+class GeoToolIndexData : public Geometry::IndexData
+{
+public:
+	GeoToolIndexData(unsigned int submeshes):Geometry::IndexData(){
+		submeshcount = submeshes;
+		indices=new unsigned int*[submeshcount];
+		indexCount=new unsigned int[submeshcount];
+		for (int i=0; i<submeshcount; i++)
+		{
+			indices[i]=NULL;
+			indexCount[i]=0;
+		}
+	}
+	virtual ~GeoToolIndexData(void){
+		for (int i=0; i<submeshcount; i++)
+			if (indices[i])
+				delete[] indices[i];
+		delete[] indices;
+		delete[] indexCount;
+	}
+
+	virtual void Begin(unsigned int submesh, unsigned int numinds){
+		if (indices[submesh])		
+			delete[] indices[submesh];
+		indices[submesh] = new unsigned int[numinds];     
+		indexCount[submesh] = numinds;
+		modifySubmesh=submesh;
+	}
+
+	virtual void SetIndex(unsigned int i, unsigned int index){
+		indices[modifySubmesh][i] = index;
+	}
+
+	virtual void End(void){}
+	virtual void BorrowIndexData(const IndexData *){}
+
+	unsigned int submeshcount;
+	unsigned int **indices;
+	unsigned int *indexCount;
+	unsigned int modifySubmesh;
+};
+
 class GeoMeshViewUI
 {
@@ -109,5 +151,5 @@
 	//	Lod tree object.
 	LodTreeLibrary	*lodTreeLib;
-	
+
 	MeshSimplifier 			*mMeshSimplifier;
 	TreeSimplifier			*mTreeSimplifier;
@@ -117,6 +159,6 @@
 
 	MeshSimplificationSequence	*oMeshSimpSequence;
-	LodStripsConstructor		*oLodStrip;
-	GeoMeshLoader				*geoMeshLoader;
+	LodStripsConstructor				*oLodStrip;
+	GeoMeshLoader								*geoMeshLoader;
 
 	inline void cb_menuFileOpen_i(fltk::Item*, void*);
@@ -288,4 +330,7 @@
 
 	public:
+
+	// the indexdata for the LOD models
+	GeoToolIndexData *lod_index_data;
 
 	GeoMeshView					*geoMeshView;
Index: GTP/trunk/Lib/Geom/shared/GeoTool/src/GeoMeshViewUI.cpp
===================================================================
--- GTP/trunk/Lib/Geom/shared/GeoTool/src/GeoMeshViewUI.cpp	(revision 1098)
+++ GTP/trunk/Lib/Geom/shared/GeoTool/src/GeoMeshViewUI.cpp	(revision 1526)
@@ -1075,5 +1075,5 @@
 					{
 						//	Create the simplification sequence.
-						createSimplificationSequence();
+						//createSimplificationSequence();
 
 						//	Show build process.
@@ -1120,7 +1120,7 @@
 					{
 						//	Create the simplification sequence.
-						createSimplificationSequence();
+						//createSimplificationSequence();
 						
-						delete	mMeshSimplifier;
+						//delete	mMeshSimplifier;
 						geoMeshView->restoreContext();
 
@@ -1211,8 +1211,11 @@
 
 				//	Simplification sequence.
-				oMeshSimpSequence = new MeshSimplificationSequence();
+				//oMeshSimpSequence = new MeshSimplificationSequence();
 
 				//	Loads a simplification sequence file.
-				oMeshSimpSequence->Load(Serializer("SimplifSequence.txt",Serializer::READ));
+				//oMeshSimpSequence->Load(Serializer("SimplifSequence.txt",Serializer::READ));
+
+				//	Simplification sequence.
+				oMeshSimpSequence =	mMeshSimplifier->GetSimplificationSequence();
 
 				//	If the simplification sequence and the mesh exist.
@@ -1224,7 +1227,5 @@
 							progress_function);
 
-//						oSerializer	= new Serializer(file_name,Serializer::Mode::WRITE);
-
-                    oLodStrip->UpdateMesh();
+					oLodStrip->UpdateMesh();
 
 					//	Deletes the previous mesh.
@@ -1243,6 +1244,6 @@
 
 					mesh_saver	=	new	GeoMeshSaver();
-//					file_name[strlen(file_name) - 4]	=	'\0';
-					
+					//					file_name[strlen(file_name) - 4]	=	'\0';
+
 					mesh_saver->leavesSubMesh=idMeshLeaves;
 					mesh_saver->leavesVB=origSubMeshVB;
@@ -1252,6 +1253,9 @@
 					delete	mesh_saver;
 					oLodStrip->Save(file_name);
+
+					//	Delete simplified mesh.
+					delete	mMeshSimplifier;
 					//	Close file.
-//						delete	oSerializer;				
+					//						delete	oSerializer;				
 				}
 				else
@@ -1262,5 +1266,5 @@
 
 				//	Deletes the siplification sequence object.
-				delete	oMeshSimpSequence;
+				//delete	oMeshSimpSequence;
 
 				if (mApplicationState==LODTREES_AUTO)
@@ -2145,9 +2149,8 @@
 	
 	secsimpl	=	mMeshSimplifier->GetSimplificationSequence();
-	
-	secsimpl->putMeshName(nombremesh); // Nombre del mesh para guardar la secuencia de simplificación
+
+	// Nombre del mesh para guardar la secuencia de simplificación.
+	secsimpl->putMeshName(nombremesh); 
 	secsimpl->Save(Geometry::Serializer("SimplifSequence.txt",Serializer::WRITE));
-
-	//delete	secsimpl;
 }
 
@@ -2325,8 +2328,10 @@
 	{
 		delete	lodStripsLib;
+		delete	lod_index_data;
 	}
 
 	//	New lod strips object.
-	lodStripsLib	=	new	LodStripsLibrary(loddata, geomesh);
+	lod_index_data	=	new GeoToolIndexData(geomesh->mSubMeshCount);
+	lodStripsLib	=	new	LodStripsLibrary(loddata, geomesh, lod_index_data);
 
 	//	Sets the slider range.
@@ -2348,9 +2353,13 @@
 	//	If there is no lod strips object.
 	if (lodTreeLib)
+	{
 		delete	lodTreeLib;
+		delete	lod_index_data;
+	}
 
 	//	New lod strips object.
 
-	lodTreeLib = new Geometry::LodTreeLibrary(lodstripsdata,treesimpseq,geomesh/*,ileafSubMesh*/);
+	lod_index_data	=	new GeoToolIndexData(geomesh->mSubMeshCount);
+	lodTreeLib = new Geometry::LodTreeLibrary(lodstripsdata,treesimpseq,geomesh,lod_index_data);
 
 	//	Sets the slider range.
@@ -2669,5 +2678,5 @@
 
 				{
-					mMetricLabel	= new fltk::Output(26, 28, 5, 25, "Metric");
+					mMetricLabel	= new fltk::Output(26, 28, 0, 25, "Metric");
 					fltk::Output* o	=	mMetricLabel;
 					o->set_vertical();
@@ -2715,5 +2724,5 @@
 
 				{
-					mMeshReductionLabel	= new fltk::Output(26, 124, 5, 25, "Mesh Reduction");
+					mMeshReductionLabel	= new fltk::Output(26, 124, 0, 25, "Mesh Reduction");
 					fltk::Output* o	=	mMeshReductionLabel;
 					o->set_vertical();
